/*
 * This file is part of FGGL.
 *
 * FGGL is free software: you can redistribute it and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * FGGL is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with FGGL.
 * If not, see <https://www.gnu.org/licenses/>.
 */

//
// Created by webpigeon on 27/06/22.
//

#ifndef FGGL_DATA_MODULE_HPP
#define FGGL_DATA_MODULE_HPP

#include "fggl/modules/module.hpp"
#include "fggl/data/storage.hpp"
#include "fggl/platform/paths.hpp"

namespace fggl::data {

	struct LocalStorage {
		constexpr static const char* name = "fggl::data::Storage";
		constexpr static const std::array<modules::ModuleService, 1> provides = {
			SERVICE_STORAGE
		};
		constexpr static const std::array<modules::ModuleService, 0> depends = {};
		static bool factory(modules::ModuleService service, modules::Services& serviceManager);
	};


} // namespace fggl::data

#endif //FGGL_DATA_MODULE_HPP
