/*
 * This file is part of FGGL.
 *
 * FGGL is free software: you can redistribute it and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * FGGL is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with FGGL.
 * If not, see <https://www.gnu.org/licenses/>.
 */

//
// Created by webpigeon on 27/06/22.
//

#ifndef FGGL_GFX_INTERFACES2_HPP
#define FGGL_GFX_INTERFACES2_HPP

#include "fggl/gfx/interfaces.hpp"
#include "fggl/display/window.hpp"

namespace fggl::gfx {

	enum class GraphicsAPI {
		OpenGL, Vulkan
	};

	struct GraphicsDetails {
		GraphicsAPI api;
		int majorVersion;
		int minorVersion;
		bool debug;
	};

	class WindowGraphics {
		public:
			constexpr const static modules::ModuleService service = modules::make_service("fggl::gfx::WindowGraphics");

			virtual GraphicsDetails config() const = 0;
			virtual Graphics* create(display::Window& window) = 0;
	};

} // namespace fggl::gfx

#endif //FGGL_GFX_INTERFACES2_HPP
