/*
 * This file is part of FGGL.
 *
 * FGGL is free software: you can redistribute it and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * FGGL is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with FGGL.
 * If not, see <https://www.gnu.org/licenses/>.
 */

//
// Created by webpigeon on 30/04/22.
//

#ifndef FGGL_PHYS_CALLBACKS_HPP
#define FGGL_PHYS_CALLBACKS_HPP

#include <functional>
#include <unordered_set>
#include "fggl/entity/entity.hpp"

namespace fggl::phys {

	using CollisionCB = std::function<void(entity::EntityID , entity::EntityID)>;

	struct CollisionCallbacks {
		constexpr static const char* name = "phys::Callbacks";
		CollisionCB onEnter = nullptr;
		CollisionCB onExit = nullptr;
		CollisionCB onStay = nullptr;
	};

	struct CollisionCache {
		constexpr static const char* name = "phys::Cache";
		std::unordered_set<entity::EntityID> collisions;
		std::unordered_set<entity::EntityID> lastFrame;
	};

} // namespace fggl::phys

#endif //FGGL_PHYS_CALLBACKS_HPP
